AbtDbmOdbcApp becomeDefault!

!AbtOdbcDatabaseConnection publicMethods !

allProcedureNamesIfError: anErrorBlock
	"Answer all the procedure names defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self procedureRT.   
	( rt isAbtError ) ifTrue: [ ^rt ].
	cursor := rt cursor. 
	rt do: [ :aRow | data add: (aRow at: 'PROCEDURE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allTableAndViewNamesIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self tableAndViewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allTableAndViewNamesWithQualifiersIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self tableAndViewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ].
	cursor := rt cursor.
	rt do: [ :aRow | |owner| ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)	"If this DBM does not support table owners - Then only display table name"
									ifTrue: [data add: ( aRow at: 'TABLE_NAME' )] 
									ifFalse: [data add: (owner , '.' , ( aRow at: 'TABLE_NAME' ))]] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allTableNamesIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self tableRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.

	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allTableNamesWithQualifiersIfError: anErrorBlock
	"Answer all the user tables defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self tableRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | |owner| ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)
									ifTrue: [data add: ( aRow at: 'TABLE_NAME' )]
									ifFalse: [data add: (owner , '.' , ( aRow at: 'TABLE_NAME' ))]] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserTableAndViewNamesForQualifiers: aCollection ifError: anErrorBlock

	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userTableAndViewRTForQualifiers: aCollection.   
	( rt isAbtError ) ifTrue: [ ^rt ].
	cursor := rt cursor.
	rt do: [ :aRow | |owner| ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)	"If this DBM does not support table owners - Then only display table name"
									ifTrue: [data add: ( aRow at: 'TABLE_NAME' )] 
									ifFalse: [data add: (owner , '.' , ( aRow at: 'TABLE_NAME' ))]] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserTableAndViewNamesIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userTableAndViewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserTableAndViewNamesWithQualifiersIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userTableAndViewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ].
	cursor := rt cursor.
	rt do: [ :aRow | |owner| ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)	"If this DBM does not support table owners - Then only display table name"
									ifTrue: [data add: ( aRow at: 'TABLE_NAME' )] 
									ifFalse: [data add: (owner , '.' , ( aRow at: 'TABLE_NAME' ))]] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserTableNamesIfError: anErrorBlock
	"Answer all the user tables defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userTableRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserTableNamesWithQualifiersIfError: anErrorBlock
	"Answer all the user tables defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userTableRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | |owner| ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)
									ifTrue: [data add: ( aRow at: 'TABLE_NAME' )]
									ifFalse: [data add: (owner , '.' , ( aRow at: 'TABLE_NAME' ))]] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserViewNamesIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self userViewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allViewNamesIfError: anErrorBlock
	"Answer all the user tables and views defined in this database."

	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self viewRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TABLE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

tableOrViewExistsNamed: aName ifError: anErrorBlock
	"Answer true if the table or view exists in the receiving database,
	 false otherwise."

	|rt indx cursor ans|
	((indx := (aName indexOf: $. startingAt: 1 ifAbsent: [nil])) isNil)
		ifTrue: [rt := self columnResultTableFromTable: aName]
		ifFalse: [rt := self columnResultTableFromTable: (aName copyFrom: (indx + 1) to: (aName size)) owner: (aName copyFrom: 1 to: (indx - 1))].
	cursor := rt cursor.
	ans := ((rt isEmpty) not).
	cursor freeResources.
	^ans! !

!AbtOdbcDatabaseConnection privateMethods !

allTypesForDriverIfError: anErrorBlock
	"This returns all the data types supported by the connected driver"
	| data rt cursor |
	data := OrderedCollection new: 10.
	rt := self allTypesForDriverRT.   
	( rt isAbtError ) ifTrue: [ ^rt ]. 
	cursor := rt cursor.
	rt do: [ :aRow | data add: (aRow at: 'TYPE_NAME')] ifError: anErrorBlock.
	cursor freeResources.
	^data!

allUserQualifiersIfError: anErrorBlock
	"Answer all the synonym names defined in this database."

	| data rt cursor |
	data := Set new: 10.
	rt := self userQualifierRT.   
	( rt isAbtError ) ifTrue: [ ^rt ].
	cursor := rt cursor. 
	rt do: [ :aRow |  |owner|  ((owner := ( aRow at: 'TABLE_OWNER' )) isNil)	
									ifFalse: [data add: owner]] ifError: anErrorBlock.
	cursor freeResources.
	^data asOrderedCollection!

sysColumnDataForProcedureNamed: aName ifError: anErrorBlock
	"Answer the minimum system column data that is necessary to build 
	 a new row for that table or view specified. Answers a dictionary with the dictionary 
	 key being the column name, the value a column info object containing the system data."
 
	| dict rt tableId indx cursor|
	dict := AbtOrderedDictionary new.
	((indx := (aName indexOf: $. startingAt: 1 ifAbsent: [nil])) isNil)
		ifTrue: [rt := self columnResultTableFromProcedure: aName]
		ifFalse: [rt := self columnResultTableFromProcedure: (aName copyFrom: (indx + 1) to: (aName size)) owner: (aName copyFrom: 1 to: (indx - 1))].     
	( rt isAbtError ) ifFalse: [
		cursor := rt cursor.
		rt do: [ :row | 
			dict at: ( row at: 'COLUMN_NAME' ) 
				  put: ( self sysColumnInfoClass fromRow: row )].
		cursor freeResources.

	].
	^dict!

sysColumnDataForTableOrViewNamed: aName ifError: anErrorBlock
	"Answer the minimum system column data that is necessary to build 
	 a new row for that table or view specified. Answers a dictionary with the dictionary 
	 key being the column name, the value a column info object containing the system data."
 
	| dict rt tableId indx cursor|
	dict := Dictionary new.
	((indx := (aName indexOf: $. startingAt: 1 ifAbsent: [nil])) isNil)
		ifTrue: [rt := self columnResultTableFromTable: aName]
		ifFalse: [rt := self columnResultTableFromTable: (aName copyFrom: (indx + 1) to: (aName size)) owner: (aName copyFrom: 1 to: (indx - 1))].     
	( rt isAbtError ) ifFalse: [
		cursor := rt cursor.
		rt do: [ :row | 
			dict at: ( row at: 'COLUMN_NAME' ) 
				  put: ( self sysColumnInfoClass fromRow: row )].
		cursor freeResources.
	].
	^dict!

sysColumnMinDataForTableOrViewNamed: aName ifError: anErrorBlock
	"Answer the minimum system column data that is necessary to build 
	 a new row for that table or view specified. Answers a dictionary with the dictionary 
	 key being the column name, the value a column info object containing the system data."
 
	| dict rt tableId indx cursor|
	dict := Dictionary new.
	((indx := (aName indexOf: $. startingAt: 1 ifAbsent: [nil])) isNil)
		ifTrue: [rt := self columnResultTableFromTable: aName]
		ifFalse: [rt := self columnResultTableFromTable: (aName copyFrom: (indx + 1) to: (aName size)) owner: (aName copyFrom: 1 to: (indx - 1))].     
	( rt isAbtError ) ifFalse: [
		cursor := rt cursor.
		rt do: [ :row | 
			dict at: ( row at: 'COLUMN_NAME' ) 
				  put: ( self sysColumnInfoClass fromRow: row )].
		cursor freeResources.

	].
	^dict!

sysIndexMinDataForTableNamed: aName ifError: anErrorBlock
	"Answer the minimum system index data for the table specified by aName."
 
	| collection rt index collation cursor|
	collection := OrderedCollection new.
	rt := self statisticsRTForTable: aName.  

	( rt isAbtError ) 
		ifFalse: [
			cursor := rt cursor.
			rt do: [ :row |
				collation := ((row at: 'COLLATION') = 'A')
						ifTrue: ['Ascending']
						ifFalse: [((row at: 'COLLATION') = 'D')
											ifTrue: ['Decending']
											ifFalse: ['Unknown']].
				index := collection 
					detect: [ :i | i name = ( row at: 'INDEX_NAME') and: [ i creator = ( row at: 'TABLE_OWNER')]] 
					ifNone: [ nil ].
				index isNil 
					ifTrue: [((row at: 'TYPE') = 0)
										ifFalse: [ collection add: ( self sysIndexInfoFromRow: row )]]
					ifFalse: [ 
						index 
							addColumn: ( row at: 'COLUMN_NAME') 
							withOrder: collation.
					].
			].
		cursor freeResources.

		].
	^collection!

sysTableDataForTableOrViewNamed: aName ifError: anErrorBlock
	"Answer the system data for the table or view specified as defined in this database.
	 Answers a table info object containing the system data."

	| index row rt cursor |
	(( index := ( aName indexOf: $. startingAt: 1 ifAbsent: [ nil ])) isNil )
		ifTrue: [ rt := self tableAndViewRTFor: aName ]
		ifFalse: [ rt := self tableAndViewRTFor: (aName copyFrom: (index+1) to: (aName size )) owner: ( aName copyFrom: 1 to: (index-1))].
	( rt isAbtError ) ifFalse: [
		cursor := rt cursor. 
		row := rt first.
		( row isAbtError ) ifTrue: [ ^row ].
		cursor freeResources.]. 
	^self sysTableInfoClass fromRow: row! !

AbtOdbcDatabaseConnection commentFor: #allTableNamesWithQualifiersIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #sysColumnMinDataForTableOrViewNamed:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #sysTableDataForTableOrViewNamed:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #sysColumnDataForTableOrViewNamed:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allTableNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserTableNamesWithQualifiersIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserTableAndViewNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #tableOrViewExistsNamed:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allTableAndViewNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserQualifiersIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #sysIndexMinDataForTableNamed:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allTableAndViewNamesWithQualifiersIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allViewNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserTableAndViewNamesForQualifiers:ifError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allTypesForDriverIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserTableNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserViewNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allProcedureNamesIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
AbtOdbcDatabaseConnection commentFor: #allUserTableAndViewNamesWithQualifiersIfError: is:
'(C) Copyright IBM Corporation, 1993, 1995. All Rights Reserved.
'!
